package dev.fyloz.trial.colorrecipesexplorer.model

import com.fasterxml.jackson.annotation.JsonIgnore
import java.util.*
import javax.persistence.*

@Entity
@Table(name = "mix_material")
data class MixMaterial(
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    override val id: Long?,

    @JsonIgnore
    @ManyToOne
    @JoinColumn(name = "mix_id")
    val mix: Mix,

    @ManyToOne
    @JoinColumn(name = "material_id")
    val material: Material,

    var quantity: Float
) : Model {
    constructor(mix: Mix, material: Material, quantity: Float) : this(null, mix, material, quantity)

    override fun equals(other: Any?): Boolean =
        other is MixMaterial && other.mix == mix && other.material == material && other.quantity == quantity

    override fun hashCode(): Int = Objects.hash(mix, material, quantity)
}

// ==== DSL ====
fun mixMaterial(
    id: Long? = null,
    mix: Mix = mix(),
    material: Material = material(),
    quantity: Float = 0f,
    op: MixMaterial.() -> Unit = {}
) = MixMaterial(id, mix, material, quantity).apply(op)

